/******************************************************************************
    Copyright (c) 1998-2000 CoWare, Inc.    ALL RIGHTS RESERVED

The following code is derived, directly or indirectly, from the SystemC
source code released by Synopsys, Inc Copyright (c) 1996-2001, Synopsys,
Inc., CoWare, Inc., Frontier Design, Inc. and others. All Rights reserved.
The contents of this file are subject to the restrictions and limitations
set forth in the SystemC Open Source License Version 2.0 (the "License");
You may not use this file except in compliance with such restrictions and
limitations. You may obtain instructions on how to receive a copy of the
License at http://www.systemc.org/.  Software distributed by Contributors
under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
ANY KIND, either express or implied. See the License for the specific
language governing rights and limitations under the License."

******************************************************************************/

/****************************************************************
    sc_pport_b.h --  superbase class for refinable ports.

    Authors
	: Harish Sarin, CoWare Inc. (harish@coware.com)
	: Cesar Quiroz, CoWare Inc. (cesar@coware.com)
        : Vijay Kumar,  CoWare Inc. (vijay@coware.com)

    MODIFICATION LOG 
    Modifier Name & Affiliation:
    Description of Modification:


****************************************************************/

#ifndef SC_PPORT_B_H
#define SC_PPORT_B_H

#include <typeinfo>

class sc_link_mp_b;

class sc_pport_b : public virtual sc_object {
 public:
	sc_pport_b(const char *NAME) : sc_object(NAME) { }
	virtual ~sc_pport_b() { }
	virtual bool is_refined() { return false; }
	bool is_leaf() { return leaf_node; }
	void make_non_leaf() { leaf_node=false; }
	virtual void add_procs(sc_async_process_handle ) { }

 private:
	bool leaf_node; // used for sensitivity check (as of now)
public:
  virtual const char *getProtocolType()=0;
};

#endif
